Subject: bug#49075: (icomplete-vertical-mode 1) not taking effect

From: [email-masked]
Date: Sun, 20 Jun 2021 01:26:08 +0200 (CEST)

From: Juri Linkov <[email-masked]>
To: [email-masked]
Subject: bug#49075: (icomplete-vertical-mode 1) not taking effect
Date: 20/06/2021 01:02:17 Europe/Paris
Cc: Lars Ingebrigtsen <[email-masked]>;
   [email-masked]

>>> > Recently, icomplete-vertical-mode was added. But calling
>>> > (icomplete-vertical-mode 1) does not enable vertical completion,
>>> > unless one has called (icomplete-mode 1) first.
>>>
>>> I think that works as designed -- as the doc string says:
>>>
>>> "Toggle vertical candidate display in `icomplete-mode' or `fido-mode'."
>>>
>>> So the mode can't just switch on icomplete-mode by itself, because it
>>> works two different modes.
>>
>> Either icomplete-vertical-mode is a regular user option or icomplete-vertical-mode
>> should enable icomplete-mode too.

>This will require adding separate `fido-vertical-mode'.

I have put forward an alternative plan

--------

Currently (icomplete-mode 1) is necessary.   And (icomplete-vertical-mode 1) is relatively new.
Emacs could ditch (icomplete-vertical-mode 1).

Instead, have a variable one can set (such functionality is already being done for completion-style).

Users can just put 

(icomplete-mode 1)
(setq icomplete-vertical 1)

--------

To disable, one could use 
(setq icomplete-vertical 0)    

Moreover one can use negative numbers
(setq icomplete-vertical -1) 

--------

To disable icomplete totally, use
(icomplete-mode 0)

--------

In summary there shall be no 

(icomplete-vertical-mode 1) 

or 

(icomplete-vertical-mode 0) 

--------

From: Juri Linkov <[email-masked]>
To: [email-masked]
Subject: bug#49075: (icomplete-vertical-mode 1) not taking effect
Date: 20/06/2021 01:02:17 Europe/Paris
Cc: Lars Ingebrigtsen <[email-masked]>;
   [email-masked]

>> > Recently, icomplete-vertical-mode was added. But calling
>> > (icomplete-vertical-mode 1) does not enable vertical completion,
>> > unless one has called (icomplete-mode 1) first.
>>
>> I think that works as designed -- as the doc string says:
>>
>> "Toggle vertical candidate display in `icomplete-mode' or `fido-mode'."
>>
>> So the mode can't just switch on icomplete-mode by itself, because it
>> works two different modes.
>
> Either icomplete-vertical-mode is a regular user option or icomplete-vertical-mode
> should enable icomplete-mode too.

This will require adding separate `fido-vertical-mode'.